Uses User
Uses Cfg

const DTLC = #201
const DTRC = #187
const DBLC = #200
const DBRC = #188
const DHOR = #205
const DVER = #186
const SHOR = #196
const SVER = #179
const DTUP = #207
const DTLT = #182
const DTRT = #199
const DTDN = #209
const SCRS = #197
const STLT = #180
const STRT = #195
const STUP = #193
const STDN = #194

Const PROGRAM = 'DopeWars for Mystic BBS'
Const ProgCR = 'Copyright Darryl Perry'
Const ProgVer = 'v0.02'


/*Structure for game data*/

Type
  PlyrRec = Record
  BBSName : String[30]
  Alias   : String[30]
  LastOn  : String[10]
  Cost    : Array [1..6] of LongInt   /*dope prices*/
  Cash    : LongInt  /*Cash on hand*/
  Bank    : LongInt  /*Cash in Bank*/
  Debt    : LongInt  /*Debt to vinnie*/
  Stash   : Array [1..6] of Integer    /*dope in your Stash*/
  Coat    : Array [1..6] of Integer    /*dope in your Pockets*/
  Guns    : Integer     /*how many Guns you have*/
  Danger  : Integer     /*how Dangerous the cops think you are*/
  Health  : Integer     /*percentage of intact flesh on your body*/
  City    : Integer     /*what City you're in*/
  LastCost: LongInt  /*last amount of money exchanged*/
  LastCity: Integer    /*the City you were in last turn*/
  DaysUsed: Integer  /*days you've been in business*/
  DaysLeft: Integer  /*days you have to pay your Debt*/
  LastVol : Integer  /*last amount of dope that changed hands*/
  Total   : Integer     /*Total of all dope in your Pockets*/
  Pockets : Integer     /*Pockets in your trenchCoat*/
  Idx     : Integer
  Turns   : Integer
  Fights  : Integer
	InTown	: Boolean
	Rank		: Integer
	LI1     : Array [1..10] of LongInt
  CH1     : Array [1..10] of Char
  II1     : Array [1..10] of Integer
  R1      : Array [1..10] of Real
	S1      : String[50]
	S2      : String[50]
	S3      : String[50]
End

Type CfgRec = Record
	GameDays	: Integer
	Turns			: Integer // Turns per day
	Pockets		: Integer 
	Health		: Integer 
	Guns			: Integer 
	Fights		: Integer 
	City			: Integer 
	Danger		: Integer 
	Cash			: LongInt
	Bank			: LongInt
	Debt			: LongInt
	TodayDate	: String
	Rating		: Boolean // PG or R
End



Var DrugName  : Array [1..6] of String 
Var CityName  : Array [1..6] of String 
Var Gun_Name  : Array [1..6] of String
Var Homey     : Array [1..6] of String
Var PlyrFile  : String = JustPath(ProgName)+'dopewars.dat'
Var NewsFile  : String = JustPath(ProgName)+'dopewars.news'
Var OldsFile  : String = JustPath(ProgName)+'dopewars.Olds'
Var Plyr      : PlyrRec
Var Othr      : PlyrRec
Var Cfg				: CfgRec
Var Lines     : Array [1..10] of String
Var Lines2    : Array [1..20] of String
Var BBSUsrCnt : Integer
Var TI1       : Integer
Var PlyrCnt   : Integer
Var MainBox		: LongInt

Procedure SaveCfg
Var Fptr	: File
Begin
	fAssign(Fptr,JustPath(ProgName)+'dopewars.cfg',66)
	fRewrite(fptr)
	fWriteRec(Fptr,Cfg)
	fClose(Fptr)
End

Procedure ReadCfg:Boolean
Var Ret	: Boolean = False
Var Fptr: File
Begin
	fAssign(Fptr,JustPath(ProgName)+'dopewars.cfg',66)
	fReset(fptr)
	If IoResult = 0 Then
		fReadRec(fptr,Cfg)
	Else Begin
		Cfg.GameDays	:=1
		Cfg.Turns			:=3
		Cfg.Pockets		:=100
		Cfg.Health		:=100
		Cfg.Guns			:=0
		Cfg.Fights		:=3
		Cfg.City			:=1
		Cfg.Danger		:=500
		Cfg.Cash			:=2000
		Cfg.Bank			:=0
		Cfg.Debt			:=5000
		Cfg.TodayDate	:=DateStr(DateTime,1)
		Cfg.Rating		:=True
		fWriteRec(Fptr,Cfg)	
	End
	fClose(Fptr)
End

Procedure SavePlyr (PlyrNo : Integer)
Var Fptr  : File
Begin
  fAssign(Fptr,PlyrFile,66)
  fReset(Fptr)
  If IOResult <> 0 Then Begin
    fReWrite(Fptr)
    Plyr.Idx:=1
  End Else
    fSeek(Fptr,(PlyrNo-1)*SizeOf(Plyr))
  fWriteRec(Fptr,Plyr)
  fClose(Fptr)
End

Function ReadPlyr (PlyrNo : Integer): Boolean
Var X		: Integer
Var Ret	: Boolean
Var Fptr: File
Begin
  fAssign(Fptr,PlyrFile,66)
  If fileExist(PlyrFile) Then
    fReset(Fptr)
  Else
    fReWrite(Fptr)

  fSeek(Fptr,(PlyrNo-1)*SizeOf(Plyr))
  Ret:=False
  If Not fEof(Fptr) Then Begin
    fReadRec(Fptr,Plyr)
    Ret:=True
  End
  fClose(Fptr)
  ReadPlyr:=Ret
End

Procedure SaveOthr (OthrNo : Integer)
Var Fptr  : File
Begin
	fAssign(Fptr,PlyrFile,66)
	fReset(Fptr)
	If IOResult <> 0 Then Begin
		fReWrite(Fptr)
		Plyr.Idx:=1
	End Else
		fSeek(Fptr,(OthrNo-1)*SizeOf(Othr))
	fWriteRec(Fptr,Othr)
	fClose(Fptr)
End

Function ReadOthr(OthrNo : Integer): Boolean
Var X   : Integer
Var Ret : Boolean
Var Fptr: File
Begin
	fAssign(Fptr,PlyrFile,66)
	If fileExist(PlyrFile) Then
		fReset(Fptr)
	Else
		fReWrite(Fptr)

	fSeek(Fptr,(OthrNo-1)*SizeOf(Othr))
	Ret:=False
	If Not fEof(Fptr) Then Begin
		fReadRec(Fptr,Othr)
		Ret:=True
	End
	fClose(Fptr)
	ReadOthr:=Ret
End

Function FindPlyr(PlyrName : String) : Integer
Var Ret  : Integer = 0
Var X    : Integer
Var Found: Boolean
Begin
  X:=1
  Found:=False
  While ReadPlyr(X) And Not Found Do Begin
    If Plyr.BBSName=UserAlias Then Begin
      Ret:=X
      Found:=True
    End
    X:=X+1
  End
  FindPlyr:=Ret
End

Procedure Add2News(Msg:String)
Begin
	AppendText(NewsFile,Msg)
	AppendText(NewsFile,'')
  AppendText(NewsFile,'|04'+PadCt(']====[########]>------ ------<[#######]====[',79,' '))
	AppendText(NewsFile,'')
End

Procedure ShowNews
Begin
	ClrScr
	DispFile(NewsFile)
	Pause
End

Procedure InitNews
Begin
	AppendText(NewsFile,'')
	AppendText(NewsFile,'|14'+PadCt(Program+' '+ProgVer,79,' '))
	AppendText(NewsFile,'')
	Add2News('|10'+PadCt('The Strait Dope News for '+Cfg.TodayDate,79,' '))
End


Procedure ShowOlds
Begin
	ClrScr
	DispFile(OldsFile)
	Pause
End

Procedure GameMaint
Begin
	If FileExist(OldsFile) Then
		FileErase(OldsFile)
	If FileExist (NewsFile) Then Begin
		FileCopy(NewsFile,OldsFile)
		FileErase(NewsFile)
	End
	InitNews	
End

Function UpdateTotal:Integer
Var I	: Integer
Var Ret	: Integer
Begin
	Ret:=0
	For I:=1 To 6 Do 
		Ret:=Ret+Plyr.Coat[I]
	UpdateTotal:=Ret
End

Procedure LooseDope(Amt:Integer)
Var J,I	: Integer=1
Begin
  J:=6
	While Amt >= 0 And J > 0 Do Begin
		I:=1
		While I <= 6 And Amt > 0 do Begin
			If Plyr.Coat[I] > 0 Then Begin
				Plyr.Coat[I]:=Plyr.Coat[I]-1
				Amt:=Amt-1
			End
			I:=I+1
		End	
    J:=J-1
	End
End



Procedure initialize_game
Var counter  : Integer                        /*counter for loops*/
Begin

  Plyr.Stash[1]:=0
  Plyr.Stash[2]:=0
  Plyr.Stash[3]:=0
  Plyr.Stash[4]:=0
  Plyr.Stash[5]:=0
  Plyr.Stash[6]:=0
  Plyr.Total:=0                     /*zero out the Stash*/
  For Counter:=1 To 6 Do Begin
    Plyr.Coat[counter]:=0
    Plyr.Stash[counter]:=0
  End
  Plyr.Cash:=Cfg.Cash	/*starting Cash*/
  Plyr.Debt:=Cfg.Debt	/*starting Debt*/
  Plyr.Bank:=Cfg.Bank
  Plyr.Guns:=Cfg.Guns
  Plyr.Pockets:=Cfg.Pockets
  Plyr.LastCost:=0      /*last amount of money exchanged*/
  Plyr.LastVol:=0      /*last amount of dope exchanged*/
  Plyr.Health:=Cfg.Health
  Plyr.DaysUsed:=1                  /*it is day 1*/
  Plyr.DaysLeft:=30                  /*and you have 30 days to pay the Debt*/
  Plyr.Danger:=Cfg.Danger
  Plyr.City:=Cfg.City
  Plyr.LastCity:=Plyr.City
	Plyr.Turns:=Cfg.Turns
End


Procedure randomize_price 
Begin  
  /*Randomize the dope prices*/
  /*coke:15001 to 30000*/
  Plyr.Cost[1]:=Random(15000)+15001
  /*smack:5001 to 15000*/
  Plyr.Cost[2]:=Random(10000)+5001
  /*dust:5001 to 10000*/
  Plyr.Cost[3]:=Random(5000)+5001
  /*acid:1001 to 5000*/
  Plyr.Cost[4]:=Random(4000)+1001
  /*herb:101 to 250*/
  Plyr.Cost[5]:=Random(150)+101
  /*rock:26 to 75*/
  Plyr.Cost[6]:=Random(50)+26
	SavePlyr(Plyr.Idx)
End

Procedure ReWriteWin
Var I1	: Integer
Begin
  For I1:=1 To 10 Do Begin
    GoToXy(42,I1+10)
    Write('                                  ')
    GoToXy(42,I1+10)
    Write(Lines[I1])
  End
End

Procedure Add2Line(S:String)
Begin
	Lines[10]:=Lines[10]+S
	ReWriteWin
End

Procedure WinWrite(S:String)
Var I1 : Byte
Begin
  For I1:=1 to 9 Do Begin
    Lines[I1]:=Lines[I1+1]
  End
  Lines[10]:=S
	ReWriteWin
End

Procedure SortScores
Var G,D,C  : Integer
Var T1,T2  : PlyrRec
Var NW1,NW2  : LongInt = 0
Begin
  If PlyrCnt < 2 Then Exit

	For G:=1 To PlyrCnt Do Begin
		ReadOthr(G)
		Othr.Rank:=1
		SaveOthr(G)
	End

	For G:=1 To PlyrCnt Do Begin
		ReadOthr(G)
		T1:=Othr
		NW1:=T1.Bank+T1.Cash
		For D:=1 To PlyrCnt Do Begin
			ReadOthr(D)
			T2:=Othr
			NW2:=T2.Bank+T2.Cash
			If T1.Idx <> T2.Idx Then Begin
				If NW1 > NW2 Then Begin
					T2.Rank:=T2.Rank+1 // Increase the rank of the lower one
					Othr:=T2
					SaveOthr(T2.Idx)		
				End
			End
		End
	End
End

Procedure ListPlyrs
Var I2,I1,X: Integer
Var NW  : LongInt
VAr C,Me: Integer
Var Box : LongInt
Var S		: String
Begin
  I1:=1
  I2:=1

  SortScores

	Me:=Plyr.Idx

  ClassCreate(Box, 'box')
  BoxHeader(Box,0,31,' Homey List ')

	BoxOptions(Box,2,False,1,15,15,15,False,0)
  BoxOpen(Box,18,2,62,23)

  GoToXy(22,3) 
  WriteLn('|14|16 Homey                       Net Worth ')
   
  For C:=1 To PlyrCnt Do Begin 
		I1:=1
	  While ReadOthr(I1) Do Begin
			If Othr.Rank = C Then Begin
	  		If Othr.InTown Then S:='|02In '
				Else S:='|09Out'
				NW:=Othr.cash+Othr.Bank
				GoToXY(19,I2+4)
				Write('|11'+PadLt(Int2Str(Othr.Rank),3,' ')+' |13'+PadRt(Othr.Alias,15,' ')+'  '+S+'  |15$'+PadLt(StrComma(NW),14,' '))
				I2:=I2+1
				If I2 % 19 = 0 Then Begin 
					ReadKey
					I2:=1
				End
			End
			I1:=I1+1  
 	 End
	End
	
  While I2 < 19 Do Begin
    GoToXY(22,I2+4)
    Write('|14|16'+PadCt(' ',38,' '))
    I2:=I2+1
  End
  ReadKey
  ReadPlyr(Me)
  BoxClose(Box)
  ClassFree(Box)
End

Function WhichPlayer:Integer
Var I,Ret	: Integer = 0
Var S,Q	: String
Var YN	: Char
Var Done	: Boolean = False
Begin

	While Not Done Do Begin
		WinWrite('|10Which Homey?')
		WinWrite('|11:')
		S:=Upper(Input(30,30,1,''))

		If Upper(S) = 'LIST' Or Upper(S) = '?' Then
			ListPlyrs
		Else Begin

			I:=1
			While ReadOthr(I) And Not Done Do Begin
				Q:=Upper(Othr.Alias)
				If Pos(S,Q) > 0 Then Begin
					Lines[10]:=''
					WinWrite('|11Who? |14'+Othr.Alias+'|11? |12[|02Y|12]|11:')
					YN:=Upper(ReadKey)
					If YN = 'Y' Then Begin
						Lines[10]:=Lines[10]+'|11 Yeah!'
						Done:=True
						Ret:=I
					End Else Begin
						Lines[10]:=Lines[10]+'|11 Nah!'
					End
				End
				I:=I+1
			End
		End
	End
	WhichPlayer:=Ret
End

Procedure ExtraMenu
Begin
  GoToXY(42,8)
  Write(' |15S|14teal, |15N|14ew Game, |15R|14eturn to Game ')
  GoToXY(42,9)
  Write('     |15L|14ist Dealers, |15H|14elp   |00|00   ')
End

Procedure MainMenu
Begin
	GoToXy(42,8)
  Write('|11 B|03uy, |11S|03ell, |11J|03et, |03Ban|11K|03, |11M|03ore Stuff|02 ')
	GoToXy(42,9)
  Write('   |11T|03ransfer dope, See |11V|03innie|02      ')
End


Procedure Build
Var I	: Integer
Begin
	ClrScr
	ClassCreate(MainBox,'box')
	BoxOptions(MainBox,2,False,2,15,15,15,False,0)
	BoxOpen(MainBox,4,3,76,21)

  WriteXY( 4, 2,14,PadCt('DopeWars for Mystic BBS '+ProgVer+' by Darryl Perry, 2012-2015',72,' '))
  WriteXY( 4, 5,2,#199+PadRt(SHOR,36,SHOR)+#180)
	WriteXY(16, 5,2,STDN)
	WriteXY(30, 5,2,STDN)
  WriteXY( 4, 7,2,#199+PadRt(SHOR,71,SHOR)+#182)

	For I:=8 To 20 Do Begin
		WriteXY(41, I,2,SVER)
		WriteXY(16, I,2,SVER)
		WriteXY(30, I,2,SVER)
	End

	I:=10
	While I <=16 Do Begin
  	WriteXY(16,I,2,STRT);
		WriteXY(17,I,2,PadRt(SHOR,13,SHOR))
  	WriteXY(30,I,2,STLT);
		I:=I+3
	End
  WriteXY(41,10,2,STRT);
  WriteXY(76,10,2,DTLT);

  WriteXY(42,10,2,PadRt(SHOR,34,SHOR))

	WriteXY(41, 3,2,DTDN)
	WriteXY(41, 4,2,SVER)

	WriteXY(16, 6,2,SVER)
	WriteXY(30, 6,2,SVER)
	WriteXY(41, 6,2,SVER)

	WriteXY(16, 7,2,SCRS)
	WriteXY(30, 7,2,SCRS)
	WriteXY(41, 7,2,SCRS)

	WriteXY(16,21,2,DTUP)
	WriteXY(30,21,2,DTUP)
	WriteXY(41,21,2,DTUP)

	MainMenu

  WriteXY(6 , 4, 3,'Day')
	WriteXY(15, 4, 3,'  You gots ')
	WriteXY(42, 4, 12,'Coke:$')
	WriteXY(59, 4, 12,'Meth:$')

	WriteXY(42, 5, 12,'Dust:$')
	WriteXY(59, 5, 12,'Acid:$')

  WriteXY( 7, 6,13,'Yo Stash')
  WriteXY(33, 6,11,'Yo Coat')
	WriteXY(42, 6, 12,'Herb:$')
	WriteXY(59, 6, 12,'Rock:$')

	WriteXY(17, 8, 14,'Cash:')
	WriteXY(17, 9, 14,'$')

	WriteXY( 5, 9, 5,'Coke:')
	WriteXY(31, 9, 3,'Coke:')

	WriteXY( 5,11, 5,'Meth:')
	WriteXY(17,11,14,'Bank:')
	WriteXY(17,12,14,'$')
	WriteXY(31,11, 3,'Meth:')

	WriteXY( 5,13, 5,'Dust:')
	WriteXY(31,13, 3,'Dust:')

	WriteXY(17,14,14,'Debt:')
	WriteXY(17,15,14,'$')
	WriteXY( 5,15, 5,'Acid:')
	WriteXY(31,15, 3,'Acid:')

	WriteXY( 5,17, 5,'Herb:')
	WriteXY(17,17,14,'GUNS:')
	WriteXY(31,17, 3,'Herb:')

	WriteXY(17,18,14,'HEALTH:')

	WriteXY( 5,19, 5,'Rock:')
	WriteXY(17,19,14,'HOLD:')
	WriteXY(31,19, 3,'Rock:')

	WriteXY(17,20,14,'P.E.:')
End

Procedure Update   /*Update screen routine*/
Begin
  SavePlyr(Plyr.Idx)
  Write('|13')
  gotoxy(12,9);Write(PadLt(StrComma(Plyr.Stash[1]),4,' '))
  gotoxy(12,11);Write(PadLt(StrComma(Plyr.Stash[2]),4,' '))
  gotoxy(12,13);Write(PadLt(StrComma(Plyr.Stash[3]),4,' '))
  gotoxy(12,15);Write(PadLt(StrComma(Plyr.Stash[4]),4,' '))
  gotoxy(12,17);Write(PadLt(StrComma(Plyr.Stash[5]),4,' '))
  gotoxy(12,19);Write(PadLt(StrComma(Plyr.Stash[6]),4,' '))
  Write('|02')
  gotoxy(18,9);Write(PadLt(StrComma(Plyr.Cash),12,' '))
  gotoxy(18,12);Write(PadLt(StrComma(Plyr.Bank),12,' '))
  gotoxy(18,15);Write(PadLt(StrComma(Plyr.Debt),12,' '))

  WriteXY(17,6,10,PadCt(CityName[Plyr.City],13,' '))

  WriteXY(48,4,13,PadLt(StrComma(Plyr.Cost[1]),10,' '))
  WriteXY(66,4,13,PadLt(StrComma(Plyr.Cost[2]),10,' '))
  WriteXY(48,5,13,PadLt(StrComma(Plyr.Cost[3]),10,' '))
  WriteXY(66,5,13,PadLt(StrComma(Plyr.Cost[4]),10,' '))
  WriteXY(48,6,13,PadLt(StrComma(Plyr.Cost[5]),10,' '))
  WriteXY(66,6,13,PadLt(StrComma(Plyr.Cost[6]),10,' '))

  gotoxy(23,17);Write(PadLt(Int2Str(Plyr.Guns),7,' '))
  gotoxy(24,18);Write(PadLt(Int2Str(Plyr.Health),6,' '))
  gotoxy(23,19);Write(PadLt(Int2Str(Plyr.Pockets),7,' '))
  gotoxy(23,20);Write(PadLt(Int2Str(Plyr.Danger),7,' '))
  Write('|03')
  gotoxy(26,4);
  If Plyr.Debt > 0 Then
      Write(PadLt(Int2str(Plyr.DaysLeft),2,' ')+' days left')
  Else 
      Write('no debts!   ')
  Write('|11')
  WriteXY(37,9,11,PadLt(StrComma(Plyr.Coat[1]),4,' '))
  gotoxy(37,11);Write(PadLt(StrComma(Plyr.Coat[2]),4,' '))
  gotoxy(37,13);Write(PadLt(StrComma(Plyr.Coat[3]),4,' '))
  gotoxy(37,15);Write(PadLt(StrComma(Plyr.Coat[4]),4,' '))
  gotoxy(37,17);Write(PadLt(StrComma(Plyr.Coat[5]),4,' '))
  WriteXY(37,19,11,PadLt(StrComma(Plyr.Coat[6]),4,' '))

  WriteXY(11,4,11,Int2Str(Plyr.DaysUsed))
  gotoxy(1,24)
End

Procedure CleanUp
Begin
  ClrScr
  WriteLn('|10Thank you for playing DOPEWARS.')
  WriteLn('')
End


Procedure Q2BBS
Begin
  SavePlyr(Plyr.Idx)
  CleanUp
  Pause
  Halt
End

Procedure Buy
Var action  : Char
Var HowMuch: LongInt
Var Drug  : LongInt 
Var Afford  : LongInt 
Var S1  : String
Begin  /*buy routine*/
  If Plyr.Turns < 1 Then Begin
		WinWrite('|12Ya can''t find no homies to deal')
		WinWrite('|12Try again tomorra')
		Exit
	End
  WinWrite('|131|05-|13C|05oke |132|05-|13M|05eth |133|05-|13D|05ust')
  WinWrite('|134|05-|13A|05cid |135|05-|13H|05erb |136|05-|13R|05ock')
  WinWrite('|11Yo, man, what you need? |11')/*print the menu*/
  Action:=OneKey('0123456CMDAHRQ',True)
  Case Action Of
    'Q':Action:='0'
    'C':Action:='1'
    'M':Action:='2'
    'D':Action:='3'
    'A':Action:='4'
    'H':Action:='5'
    'R':Action:='6'
  End

	If Action = '0' Then Begin
		If Cfg.Rating Then Add2Line('|12 Fuck you!')
		Else Add2Line('|10 Whatever!')
		Exit
	End
		
  drug:=Ord(action)-Ord('1')+1                /*convert character to digit*/
  Lines[10]:=Lines[10]+Upper(DrugName[drug])       /*print your choice*/
  If Plyr.Cash < Plyr.Cost[drug] Then Begin                            
    /*see if you can afford it*/
    WinWrite('|13You can''t afford no '+DrugName[drug]+'!!')
  End Else Begin
    Afford:=Plyr.Cash/Plyr.Cost[drug]
    /*how much you can afford*/
    WinWrite('|13You can afford |14'+StrComma(Afford))
    /*how much you can hold*/
    WinWrite('|13and you can carry |14'+Int2Str(Plyr.Pockets))
    WinWrite('|11How much you want, Homey: |14')
    If Afford > Plyr.Pockets Then
      Afford:=Plyr.Pockets
    S1:=Input(8,20,1,Int2Str(Afford))
    If S1 = '.' Then Begin
      If Afford <= Plyr.Pockets Then Begin
        HowMuch:=Afford
      End Else 
        HowMuch:=Plyr.Pockets
    End Else 
      HowMuch:=Str2Int(S1)        /*convert a string*/

    Add2Line('|11'+StrComma(HowMuch))
    If Plyr.Pockets < HowMuch Then Begin                        
      WinWrite('You can''t carry all that!')
    End Else Begin
      Afford:=Plyr.Cost[drug]*HowMuch
      If Plyr.Cash < Afford Then Begin
        WinWrite('|12What you take me fo?')
        WinWrite('|12You can''t afford that!')
      End Else Begin                    
        Plyr.LastCost:=Afford
        Plyr.Cash:=Plyr.Cash-Afford
        Plyr.LastVol:=HowMuch
        Plyr.Coat[drug]:=Plyr.Coat[drug]+Plyr.LastVol
        Plyr.Pockets:=Plyr.Pockets-HowMuch
        Plyr.Total:=Plyr.Total+Plyr.LastVol
      End
    End
  End
End

/*sell routine--a lot like the buy routine*/
Procedure Sell 
Var Action  : Char
Var S1    : String
Var Drug  : Byte
Var HowMuch  : Integer
Var Amount  : Integer
Begin 
  If Plyr.Turns < 1 Then Begin
		WinWrite('|12Ya can''t find no homies to deal')
		WinWrite('|12Try again tomorra')
		Exit
	End
  WinWrite('|121|04-|12C|04oke |122|04-|12M|04eth |123|04-|12D|04ust')
  WinWrite('|124|04-|12A|04cid |125|04-|12H|04erb |126|04-|12R|04ock')
  WinWrite('|12Yo, man, what you got? |15')
  Action:=OneKey('QCMDAHR1234560',True)
  Case Action Of
    'Q':Action:='0'
    'C':Action:='1'
    'M':Action:='2'
    'D':Action:='3'
    'A':Action:='4'
    'H':Action:='5'
    'R':Action:='6'
  End

	If Action = '0' Then Begin
		WinWrite('|12fuck you!')
		Exit
	End
  Drug:=Ord(action)-Ord('1')+1
  Lines[10]:=Lines[10]+Upper(DrugName[drug]) /*Plyr.how much you have*/
  If Plyr.Coat[drug] = 0 Then /*instead of how much you want*/
    WinWrite('|12You ain''t got no '+DrugName[Drug]+'!')
  Else Begin    /*print it for reference*/
    WinWrite('|12You gots |04'+Int2Str(Plyr.Coat[drug])+'|12 '+DrugName[drug]+'.')
    WinWrite('|12How you sellin'', G? : |15')
    Amount:=Plyr.Coat[drug]
    S1:=Input(8,20,1,Int2Str(Amount))
    Lines[10]:=Lines[10]+S1
    If S1 = '.' Then Begin
      Lines[10]:=Lines[10]+' |12All'
      HowMuch:=Amount
    End Else 
      HowMuch:=Str2Int(S1)  /*convert it*/
    If Plyr.Coat[drug] < HowMuch Then /*and validate*/
      WinWrite('|12Yo, man, you takin'' me fo a fool?')
    Else Begin      /*Update the info*/
      Plyr.Cash:=Plyr.Cash+(Plyr.Cost[drug]*HowMuch)
      Plyr.LastCost:=Plyr.Cost[drug]*HowMuch
      Plyr.Coat[drug]:=Plyr.Coat[drug]-HowMuch
      Plyr.LastVol:=HowMuch
      Plyr.Pockets:=Plyr.Pockets+HowMuch
      Plyr.Total:=Plyr.Total+HowMuch
    End
  End
End


/*jet routine*/
Procedure Jet  
Var Action  : Char
Var City  : Byte
Var X,C    : Byte
Begin

	If Plyr.Turns < 1 Then Begin
		WinWrite('|12Ya be too tired.  Try tomorra')
		Exit
	End
  Plyr.LastCity:=Plyr.City
  WinWrite('|111|03-|11R|03ockville |112|03-|11N|03orthwest')
  WinWrite('|113|03-|11S|03outheast |114|03-|11A|03rlington')
  WinWrite('|115|03-The |11M|03all  |116|03-A|11l|03exandria')
  WinWrite('|11Where you be going?  |03')
  Action:=OneKey('123456RNSAML',True)
  Case Action Of
    'R':Action:='1'
    'N':Action:='2'
    'S':Action:='3'
    'A':Action:='4'
    'M':Action:='5'
    'L':Action:='6'
  End
  City:=Ord(Action)-Ord('1')+1
  Lines[10]:=Lines[10]+Upper(CityName[City])          /*validate it*/
  If Plyr.City = City Then
    WinWrite('You is already there!!!')
  Else Begin
    gotoxy(17,6)
    If Plyr.Cash>=3 Then Begin
			Randomize_Price
      Plyr.City:=City              /*Update it*/
      Write('|11   METRO   |DE|DE|DE|DE')
      WinWrite('|03You hops on de metro.')
      Plyr.Cash:=Plyr.Cash-3
			Plyr.Turns:=Plyr.Turns-1
			SavePlyr(Plyr.Idx)
    End Else Begin
      Write('|11 HITCHHIKING |DE|DE|DE|DE')
      WinWrite('I bet you wish you coulds afford')
      WinWrite('de metro rail!!!')
      C:=1
      Repeat
        Write('|DE|DE')
        WinWrite('|06Here come somebody!')
        Write('|DE|DE')
        WinWrite('|09Hey! It be '+Homey[random(6)+1]+'!')
        X:=Random(6)+1
        If X > 5 Then Begin
					Randomize_Price
          WinWrite('|10He gives you a ride!')
          WinWrite('|10You gets in de car!!!')
          gotoxy(18,6)
          Write('|11 IN DE CAR ')
          Write('|DE|DE')
          Write('|DE|DE')
          X:=0
					Plyr.Turns:=Plyr.Turns-1
    			Plyr.City:=City              /*Update it*/
					SavePlyr(Plyr.Idx)
        End Else
					If Cfg.Rating Then
          	WinWrite('|12De cocksucker don''t stop!')
					Else
          	WinWrite('|12yo homey don''t stop!')
        Write('|DE|DE')
        C:=C+1
      Until X = 0 Or C<10

      Write('|03|DE|DE|DE')
    End
  End
End

/*Transfer routine for Stash*/
Procedure Transfer 
Var Amount  : Integer
Var Counter  : Integer
Var Action  : Char
Var Drug  : Integer
Var S1    : String
Begin 
  /*put all the dope in the Stash*/
  WinWrite('Transfer dope')
  WinWrite('You puts yo dope in de Stash.')
    For counter:=1 To 6 Do Begin
    Plyr.Stash[counter]:=Plyr.Stash[counter]+Plyr.Coat[counter]
    Plyr.Coat[counter]:=0
  End
  Plyr.Pockets:=Plyr.Pockets+Plyr.Total
  Plyr.Total:=0
  Repeat
    Action:='8'
    while Action <> 'Q' And Action <> 'L' Do Begin
      Update
      WinWrite('|131|05-|13C|05oke |132|05-|13S|05mack |133|05-|13D|05ust')
      WinWrite('|134|05-|13A|05cid |135|05-|13H|05erb  |136|05-|13R|05ock |13Q|05-|13L|05eave')
      WinWrite('|11What you gettin'' out?: |11')
      Action:=OneKey('CSDAHRLQ123456',True)
      Case Action Of 
        'C': Action:='1'
        'S': Action:='2' /*convert it*/
        'D': Action:='3'
        'A': Action:='4'
        'H': Action:='5'
        'R': Action:='6'
        'L': Action:='Q'
      End
      If Pos(Action,'123456') > 0 Then Begin
        drug:=Ord(action)-Ord('1')+1
        Lines[10]:=Lines[10]+Upper(DrugName[drug])
        If Plyr.Stash[drug] = 0 Then Begin /*validate it*/
          WinWrite('|12You ain''t gots no '+DrugName[drug]+'!!!')
        End Else Begin
          WinWrite('|13You gots |14'+Int2Str(Plyr.Stash[drug])+' '+DrugName[drug]+'.')
          WinWrite('|13How much |14'+DrugName[drug]+' |13ya takin: |11')
          Amount:=Plyr.Stash[drug]
          S1:=Input(7,7,1,Int2Str(Amount))
          Lines[10]:=Lines[10]+S1
          If S1 = '.' Then Begin
            Lines[10]:=Lines[10]+'|11All'
            Amount:=Amount
          End Else 
            Amount:=Str2Int(S1)      /*convert amount*/
          If Amount > Plyr.Stash[drug] Then /*validate*/
            WinWrite('You ain''t gots that much '+DrugName[drug]+'!')
          Else Begin                    /*Update info*/
            Plyr.Coat[drug]:=Plyr.Coat[drug]+Amount
            Plyr.Total:=Plyr.Total+Amount
            Plyr.Stash[drug]:=Plyr.Stash[drug]-Amount
            Plyr.Pockets:=Plyr.Pockets-Amount
          End
        End
      End
    End
  Until Action = 'Q'
End

/*Bank routine*/
Procedure Deposit
Var S1    : String
Var Depo  : LongInt
Begin 
  WinWrite('|10How much to deposit: |11')
  S1:=Input(10,10,1,'')
  If S1 = '.' Then Begin
    Depo:=Plyr.Cash
  End Else 
    Depo:=Str2Int(S1)
    If Plyr.Cash >= Depo Then Begin /*validate it*/
      Plyr.Cash:=Plyr.Cash-Depo
      Plyr.Bank:=Plyr.Bank+Depo
      Lines[10]:=Lines[10]+' |11'+Int2Str(Depo)
    End Else Begin
      WinWrite('|10Let us know when you have it.')
  End
  Update
End

Procedure Withdraw
Var S1    : String
Var Depo  : LongInt
Begin
  WinWrite('|10How much to withdraw: |11')
  S1:=Input(10,10,1,'')
  If S1 = '.' Then Begin
    Depo:=Plyr.Bank
  End Else 
    Depo:=Str2Int(S1)

  If Plyr.Bank >= Depo Then Begin
    Lines[10]:=Lines[10]+' |11'+Int2Str(Depo)
    Plyr.Cash:=Plyr.Cash+Depo
    Plyr.Bank:=Plyr.Bank-Depo
    WinWrite('|10Nice doing business with you!')
  End Else Begin
    WinWrite('|10I''m sorry, but that would')
    WinWrite('|10be a substantial overdraft.')
  End
End

Procedure Bank
Begin
  Deposit
  Withdraw
End


Procedure Encounter
Var Event  : Integer
Var Number : Integer
Var Price  : LongInt
Var Util   : Char
Var RR,PP,I1 : Integer
Begin 
  /*10% chance of being mugged*/
  Event:=Random(100)+1
  If Event>90 And Plyr.Cash > 5000 Then Begin
    /*only if he has over $5000*/
    WinWrite('|02You was mugged in de streets!!!')
    /*take half his money*/
    Plyr.Cash:=Plyr.Cash/2          
    Update      
  End
  Event:=Random(100)+1          /*10% chance of high price*/
  Number:=Random(6)+1
  If Event>90 Or Plyr.Cost[number]=1 Then Begin
    /*if low.Cost, default here*/
    Write('|04')
    Case Number Of
      1: Begin
        WinWrite('Cops raided the mayor''s office!')
        WinWrite('Coke is primo now!')
        End
      2: Begin
        WinWrite('Addicts are paying outrageous')
        WinWrite('prices for heroin!')
        End
      3: Begin
        WinWrite('Labs was raided all over town!')
        WinWrite('Dust is scarce!')
        End
      4: Begin
        WinWrite('The mob is squeezing LSD labs!')
        End
      5: Begin
        WinWrite('Weed supplies are drying up!')
        End
      6: Begin
        WinWrite('Crackheads is paying through')
        WinWrite('the nose for smoke!')
        End
    End
    Plyr.Cost[number]:=Plyr.Cost[number]*(Random(20)+1)/*multiply by 1 to 20*/
    Update
  End Else Begin
    /*10% chance of low price*/
    /*if high.Cost default here*/
    If Event>85 Or Plyr.Cost[number]>3000000000 Then Begin
      number:=6-number        /*reverse order of numbers*/
      WinWrite('|04')
      Case Number Of
        1: Begin
          WinWrite('Jamaican posse raided the DEA!')
          WinWrite('Coke is everywhere!')
        End
        2: Begin
          WinWrite('Pigs are selling cheap heroin')
          WinWrite('from a raid!')
        End
        3: Begin
          WinWrite('The lab made too much dust!')
          WinWrite('They is selling it cheap!')
        End
        4: Begin
          WinWrite('The Grateful Dead are playing')
          WinWrite('Rat RFK!')
        End
        5: Begin
          WinWrite('Columbian freighter dusted')
          WinWrite('the Coast Guard!  Weed prices')
          WinWrite('have bottomed out!')
        End
        6: Begin
          WinWrite('Rival dope dealers is')
          WinWrite('undercutting the rock market!')
            End
      End
    End
    Plyr.Cost[number]:=Plyr.Cost[number]/(Random(20)+1)/*divide by 1 to 20*/
    If Plyr.Cost[number]<1 Then Plyr.Cost[number]:=1
    Update    /*Update the screen*/
  End

  Event:=Random(100)+1
  Number:=Random(6)+1
  If Event>90 Then Begin                /*straight ten percent*/
    /*chance of gun offer*/
    price:=Random(250)+251
    If Plyr.Cash>=Price Then Begin
      WinWrite('|03Would you like to buy')
      WinWrite('|03a|11'+Gun_Name[number]+' |03fo $|11'+Int2Str(price)+'|03?')
      Util:=OneKey('YN',True)
      If util='Y' Then Begin    /*if you can afford it*/
	      Plyr.Guns:=Plyr.Guns+1
	      Plyr.Cash:=Plyr.Cash-Price
 				Plyr.Pockets:=Plyr.Pockets-5
				If Plyr.Pockets < Plyr.Total Then
					LooseDope(Plyr.Total-Plyr.Pockets)
				Add2Line(' Word up!')
      End Else Begin
				If Cfg.Rating Then
	        Add2Line('|12 Fuck You!')
				Else
	        Add2Line('|10 Whatever!')
      Update                /*Update the screen*/
			End
    End
  End

  Event:=Random(100)+1
    If Event>90 Then Begin      /*of a pocket sale*/
    price:=Random(150)+101
    If Plyr.Cash>=Price Then Begin
      WinWrite('|05Georgetown Leather Design')    /*same idea as Guns*/
      WinWrite('|05has a sale! Mo Pockets')
      WinWrite('|05fo $|13'+Int2Str(Price)+'|05? : |11')
      Util:=OneKey('YN',True)
      If util='Y' Then Begin
        Add2Line('|10 Word up!')
        Plyr.Pockets:=Plyr.Pockets+10
        Plyr.Cash:=Plyr.Cash-Price
      	Update
      End Else Begin
				If Cfg.Rating Then
        	Add2Line('|12 Fuck You!')
				Else
        	Add2Line('|10 Whatever!')
			End
    End
  End

  Event:=Random(100)+1
  Number:=Random(6)+1
  If Event>95 Then Begin
    Price:=Random(10)+1
    If Plyr.Coat[number]>0 Then Begin
      WinWrite('|02You cut yo Stash of |10'+DrugName[number]+'|02!')
      WinWrite('|02You gots |10'+Int2Str(Price)+' |02more!')
    End Else Begin
      WinWrite('|02You find |10'+Int2Str(Price)+' '+DrugName[number]+' |02on')
      WinWrite('|02a dead dude in de alley!')
    End
		PP:=Plyr.Total+Price
		If PP >= Plyr.Pockets Then Begin
	    Plyr.Coat[number]:=Plyr.Coat[number]+Price
 			Plyr.Total:=Plyr.Total+Price
			Plyr.Pockets:=Plyr.Pockets-Price
			Update    /*Update the screen*/
		End Else Begin
			WinWrite('|12You haz no spare pockets, foo!')
		End
  End

  Event:=Random(20)+1
  Number:=Random(6)+1
  Price:=0
  For I1:=1 To 6 Do 
    Price:=Price+Plyr.Stash[I1]

  If Event>19 And Price > 100 And Plyr.City > 0 Then Begin
    WinWrite('|05Yo Stash has got raided!')
    For I1:=1 To 6 Do 
      Plyr.Stash[I1]:=Plyr.Stash[I1]/2
    Update          /*Update the screen*/
  End

  Event:=Random(20)+1
  If Event>19 And Plyr.Guns > 0 Then Begin 
    /*Guns that somebody will steal one*/
    WinWrite('|04One of yo Guns has got stolen!')
    Plyr.Guns:=Plyr.Guns-1
    Plyr.Pockets:=Plyr.Pockets+5
    Update
  End

  Event:=Random(100)+1
  If Event>99 Then Begin
    Number:=0
    If Plyr.Cash>1000000 And Plyr.Bank>1000000 Then
      Number:=1
    If Plyr.Bank>4000000000 Then 
      Number:=1
    If Number > 0 Then Begin
      WinWrite('|02De Bank been robbed!')
      Plyr.Bank:=Plyr.Bank/2          /*cut it in half*/
      Update
    End
  End

  Event:=Random(20)+1
  Number:=Random(6)+1
  Price:=Random(10)+1
  If Event>18 Then Begin      /*of dropping any dope you may have*/
    WinWrite('|14Police dogs chase you')
    WinWrite('|14fo |06'+Int2Str(Price)+' |14blocks!')
    If Plyr.Coat[number]>0 Then Begin
      WinWrite('|14You dropped some dope!')
			If Plyr.Coat[Number] <= 10 Then Begin
	      Plyr.Pockets:=Plyr.Pockets+Plyr.Coat[number]
				Plyr.Total:=Plyr.Total-Plyr.Coat[Number]
	      Plyr.Coat[number]:=0
			End Else Begin
				Plyr.Coat[Number]:=Plyr.Coat[Number]-10
				Plyr.Total:=Plyr.Total-10
			End
			SavePlyr(Plyr.Idx)
      Update
    End
  End

  Event:=Random(100)+1
  Number:=Random(10)+1
  Price:=0
  If (Plyr.Debt>0 And event>99) Then Price:=1
  If Price > 0 Or Plyr.Debt>4000000000 Then Begin
      Write('|05Vinnie''s bookkeeper fucked up!')
    Plyr.Debt:=Plyr.Debt/number
    Update
  End
  Event:=Random(20)+1
  If Event>19 Then Begin
    WinWrite('|09You ripped yo Coat!')
    Plyr.Pockets:=Plyr.Pockets-10
		If Plyr.Pockets > 0 And Plyr.Pockets < Plyr.Total Then Begin
			LooseDope(Plyr.Total-Plyr.Pockets)
		End
    Update
  End
End

Procedure Caught
Var Rand  : Integer
Begin
  WinWrite('can''t lose them!!!')
  WinWrite('You has been caught!')
  WinWrite('You goes to jail fo')
  Rand:=Random(10)+1
  WinWrite(Int2Str(Rand)+' years!!!')
  Plyr.DaysUsed:=Plyr.DaysUsed+(Rand*365)
  Plyr.Guns:=0
  Plyr.Bank:=0
  Plyr.Danger:=Plyr.Danger+Rand
  If Plyr.Danger>500 Then Plyr.Danger:=500
  Plyr.Pockets:=Plyr.Pockets+Plyr.Total
  Plyr.Total:=0
  For Rand:=1 to 6 Do
    Plyr.Coat[rand]:=0
  If Plyr.Debt > 0 Then Begin
    WinWrite('Vinnie be nice and')
    WinWrite('don''t charge you no')
    WinWrite('interest while you is')
    WinWrite('locked up.')
  End
  Rand:=Plyr.DaysUsed/365
  If Rand >= 20 Then Begin
    clrscr
    WinWrite('|09By de time you gets out ')
    WinWrite('you is far too old to be')
    WinWrite(' doing this shit.')
    WinWrite('You decides to retire ')
    WinWrite('and be legal fo de rest of ')
    WinWrite('yo life.')
    CleanUp
    Pause
    Exit
  End
End

Procedure Killed
Begin
  clrscr
  WriteLn('|12You has been Killed in de process of selling dope to yo fellow man.')
  WriteLn('De cops takes all yo money and dope and throws it in de evidence locker.')
  WriteLn('But don''t be worrying yo dead self about all de dope and Cash some pigs')
  WriteLn('will haves it on de street befo de weekend!  You has managed to sell dope')
  WriteLn('fo '+Int2Str(Plyr.DaysUsed)+' days, which is mo than most people could manage to think about it!')
  CleanUp
  Pause
  Exit
End

Procedure TheCops 
Var Cops  :Integer
VAr Rand  :Integer
Var Util  :Char
Begin
  If Plyr.LastCost >= 1000000 Then   /*if you bought or sold $1,000,000*/
    Rand:=1
  If Plyr.LastVol >= 100 Then  /*if you bought or sold over 100*/
    Rand:=1
  If Plyr.Cash >= 10000000 Then   /*if you have $10,000,000 on you*/
    Rand:=1
  If Plyr.Total >= 1000 Then    /*or if you have over 1000 on you*/
    Rand:=1
  If Rand > 0 Then Begin                      
    /*you meet the cops*/
    WinWrite('|04De cops! Oh shit!')/*# of cops depends on PE number*/
    Cops:=501-Plyr.Danger
    Cops:=(Cops/10)+1
    Cops:=Random(Cops)
    While Cops > 0 And Plyr.Health > 0 And Plyr.Health <= 100 Do Begin
      Update
      WinWrite('|04They is |12'+Int2Str(Cops)+' |04of em!')
      WinWrite('|10Does you fight? ')
      Util:=OneKey('YN',True)
      If Util='N' Then Begin
        Lines[10]:=Lines[10]+' No'
        /*if you say no*/
        If Plyr.Guns > 0 Then Begin
          /*if you have Guns, they shoot*/
          WinWrite('They sees yo Guns!')
          WinWrite('They shoots at you!')
          Rand:=Cops+Plyr.Guns
          Rand:=Random(Rand)
          If Rand > Plyr.Guns Then Begin
            WinWrite('They hits you!')
            Plyr.Health:=Plyr.Health-Cops
            Update
          End Else 
            WinWrite('They missed you!')
        End
        Rand:=Random(6)+1
        WinWrite('You tries to run but you')
        If Rand<6 Then Begin                
          /*see if you get away*/
          Rand:=Random(6)+1
          If Rand > 5 Then Begin
            cops:=0
            Caught
          End
        End Else Begin                
          /*1 in 6 chance*/
          WinWrite('You gots away!')
          cops:=0
        End
      End Else Begin
        If Plyr.Guns<1 Then Begin
          /*if you have no Guns, you can't shoot them*/
          WinWrite(' Yes')
          WinWrite('You gots no Guns!')  /*but they can*/
          WinWrite('They shoots at you!')/*shoot at you*/
          Rand:=Random(Cops+Plyr.Guns)+1
          If Rand > Plyr.Guns Then Begin
            WinWrite('They hits you!')
            Plyr.Health:=Plyr.Health-cops
            Update
            Write('|04')
          End Else 
            WinWrite('They missed you!')
        End Else Begin
          /*of course you can kill someone on full autofire*/
          WinWrite(' Yes')
          WinWrite('You shoots at them!')
          Rand:=Random(Plyr.Guns+cops)+1
          If Rand > cops Then Begin
            WinWrite('You kills one!')
            Cops:=Cops-1
            Plyr.Danger:=Plyr.Danger-1
            If Plyr.Danger < 1 Then Plyr.Danger:=1
          End Else 
            Write('You missed!')

          If Cops > 0 Then Begin
            WinWrite('They shoots at you!')
            Rand:=Random(Cops+Plyr.Guns)+1
            If Rand > Plyr.Guns Then Begin
              WinWrite('They hits you!')
              Plyr.Health:=Plyr.Health-(cops+1)
              Update
              Write('|04')
            End Else 
              WinWrite('They missed you!')
          End Else Begin   
            /*if you kill them all*/
            WinWrite('You waxed them, Homey!')
            WinWrite('|12')
            WinWrite('You is public enemy number '+Int2Str(Plyr.Danger)+'!')
          End
        End
      End /*if you died, call the Killed routine*/

      If Plyr.Health<=0 Or Plyr.Health>100 Then Killed
      Plyr.LastCost:=0
      Plyr.LastVol:=0/*reset counters*/
      Update                /*Update screen*/
    End
  End
End

/*a one-way Bank*/
Procedure vinnie 
Var S1    : String
Var Payment  : LongInt
Begin 
  Add2Line('|05See Vinnie')
  WinWrite('You goes to de Eye-talian')
  WinWrite('restamaraunt.')
  If Plyr.Debt > 0 Then Begin
    WinWrite('Vinnie be sittin'' here giving')
    WinWrite('you de evil eye.')
    WinWrite('|10How much you pays ''m?: |11')
    S1:=Input(10,10,1,'')
    If S1 = '.' Then Begin
      If Plyr.Cash<Plyr.Debt Then 
        Payment:=Plyr.Cash
      Else 
        Payment:=Plyr.Debt /*Plyr*/
    End Else 
      Payment:=Str2Int(S1)

    Lines[10]:=Lines[10]+'$'+Int2Str(Payment)
    If Plyr.Cash < Payment Then Begin
        WinWrite('|13You ain''t gots the money!')
      WinWrite('|13He smacks you!')
        Plyr.Health:=Plyr.Health-5
      End Else Begin
      If Plyr.Debt < Payment Then Begin
        WinWrite('|05Vinnie smiles and accepts yo')
        WinWrite('|05gracious bonus.')
        Plyr.Debt:=Payment
      End
      Plyr.Debt:=Plyr.Debt-Payment
      Plyr.Cash:=Plyr.Cash-Payment
    End
  End Else Begin
      WinWrite('|05Vinnie be sittin'' here giving you')
    WinWrite('de big grin.')
      WinWrite('|10How much you borrows?: |11')
    S1:=Input(10,10,1,'')
    If S1 = '.' Or S1 = '' Or S1 = '0' Then Begin
      Lines[10]:=Lines[10]+'|11Nothing'
      Payment:=0
    End Else Begin
      Payment:=Str2Int(S1)
      Plyr.Debt:=Plyr.Debt+Payment   
      Plyr.Cash:=Plyr.Cash+Payment   
      Plyr.DaysLeft:=30    
      Lines[10]:=Lines[10]+'$'+StrComma(Payment)
    End
  End
End

Procedure online_help
Begin
   WinWrite('The object of DOPEWARS is to')
   WinWrite('become a rich dope dealer.')
   WinWrite('You must buy low and sell high')
   WinWrite('to achieve this goal.  If you')
   WinWrite('deal heavily in dope, you will')
   WinWrite('run into the cops. The cops')
   WinWrite('will only shoot you if you have')
   WinWrite('guns (threat) or if you fight')
   WinWrite('(resisting arrest).  If the')
   WinWrite('cops catch you, you will go')
  GoToXy(42,20);Write('|PN')
  
   WinWrite('to jail.  You start the game')
   WinWrite('with a $5000 dollar debt to')
   WinWrite('Vinnie the loan shark, which')
   WinWrite('you must pay in thirty days.')
   WinWrite('Once you pay Vinnie off, he')
   WinWrite('will loan you more money if you')
   WinWrite('want.  Every thirty days, you')
   WinWrite('must pay $3000 dollars in cost')
   WinWrite('of living expenses. If you')
   WinWrite('cannot afford it, you will')
  GoToXy(42,20);Write('|PN')

   WinWrite('automatically borrow more')
   WinWrite('money from Vinnie.  If you')
   WinWrite('have a lot of dope, you can')
   WinWrite('Transfer dope and put it in')
   WinWrite('your stash if you have a lot')
   WinWrite('of money, you can Go to bank')
   WinWrite('and put it in savings.  You')
   WinWrite('must use cash in all your deals')
   WinWrite('except the bills dope dealers')
   WinWrite('and loan sharks don''t take')
  GoToXy(42,20);Write('|PN')

   WinWrite('checks.  Every year, your')
   WinWrite('friends will wish you a')
   WinWrite('happy anniversary and give')
   WinWrite('you some dope.  The screen')
   WinWrite('is relatively easy to read')
   WinWrite('your stash is on the left,')
   WinWrite('your coat pockets on the right,')
   WinWrite('and separating them is a little')
   WinWrite('financial statement of your')
   WinWrite('cash, bank balance, and debt.')
  GoToXy(42,20);Write('|PN')
   WinWrite('Under the financial statement')
   WinWrite('is a list of your abilities')
   WinWrite('how many guns you have, how')
   WinWrite('much health you have (if you')
   WinWrite('get shot, you will lose some')
   WinWrite('every day you get one point of')
   WinWrite('health back), how much dope you')
   WinWrite('can carry (your pockets), and')
   WinWrite('where you are on the most wanted')
   WinWrite('list (500 when you start).')
  GoToXy(42,20);Write('|PN')
   WinWrite('It is worth noting that it costs')
   WinWrite('3 dollars to ride the metro, so')
   WinWrite('always keep a little bit of cash.')
   WinWrite('If you have no money, you will')
   WinWrite('have to hitchhike.')
   WinWrite('|10DOPEWARS ')
   WinWrite('|12by Caliban Tiresias')
   WinWrite('Darklock, ')
   WinWrite('|14(C) 1993, ')
   WinWrite('product of')
   WinWrite('Trinity Logical Cybersystems,')
   WinWrite('All Rights Reserved.')
   WinWrite('|14Press any key...')
  GoToXy(42,20);Write('|PN')
End

Procedure Steal
Var I1,I2 : Integer=1
Var Dt,Me : Integer=Plyr.Idx
Var Ch    : Char
Var LI		: LongInt
Begin
	If Plyr.Fights <= 1 Then Begin
		WinWrite('|12Try again tomorrow')
		Exit
	End
	I2:=WhichPlayer
	If I2 < 1 Then Begin
		If Cfg.Rating Then
			Add2Line('|12Fuck You!')
		Else
			Add2Line('|12Whatever!')
		Exit
	End

	If Othr.Idx = Plyr.Idx Then Begin
		WinWrite('Steal from yo''self? Nope!')
		Exit
	End

  If ReadOthr(I2) Then Begin

		If Not Othr.InTown Then Begin
			WinWrite('|12He be hiding out')
			Exit
		End
    WinWrite('|12Steal |131|12-|13M|12oney  |132|12-|13D|12rugs')
    WinWrite('|11Which one, G? ')
    Ch:=OneKey('012DMQ',True)
		If Ch = '0' Or Ch = 'Q' Then begin
			If Cfg.Rating Then
				WinWrite('|10Pussy!')
			Else
				WinWrite('|10Wimp!')
			Exit
		End
		If Ch = '1' or Ch = 'M' Then
      Lines[10]:=Lines[10]+' Money'
		If Ch = '2' or Ch = 'D' Then
      Lines[10]:=Lines[10]+' Drugs'
		ReWriteWin

		If Othr.Guns >= Plyr.Guns Then Begin
			WinWrite(Othr.Alias + ' be packin'' heat!')
			If Cfg.Rating Then
				WinWrite('You runs away like a little pussy!')
			Else
				WinWrite('You runs away like a little girl!')
			Exit	
		End Else Begin
			WinWrite('|14He be out-gunned!')
		End

    If Ch = '1' Or Ch = 'M' Then Begin
			LI:=Random(Othr.Cash)
			Othr.Cash:=Othr.Cash-LI
			Plyr.Cash:=Plyr.Cash+LI
			Plyr.Danger:=Plyr.Danger-1
			Othr.InTown:=False
			SaveOthr(Othr.Idx)
			SavePlyr(Plyr.Idx)
			WinWrite('|10You grabbed |11$'+Int2Str(LI))
			WinWrite('|12'+Othr.Alias+' is pissed!')
			Add2News('  |03Street dealer, |07'+Othr.Alias+'|03, was robbed on the streets.')
		End

		If Ch = '2' Or Ch = 'D' Then Begin
			DT:=Othr.Coat[1]
			DT:=DT+Othr.Coat[2]
			DT:=DT+Othr.Coat[3]
			DT:=DT+Othr.Coat[4]
			DT:=DT+Othr.Coat[5]
			DT:=DT+Othr.Coat[6]

			DT:=DT/10
		End
	End

  ReadPlyr(Me)  
	MainMenu
  Update  
End

Procedure ExtraFunctions
Var Action   : Char
Begin
	ExtraMenu
  WinWrite('|11Extra Stuff : ')
  Action:=OneKey('LSRNCBMH',True)
  Case Action Of
    'L': Begin
				Add2Line('|10List Homeys')
				ReWriteWin
				ListPlyrs; 
				End
    'N':Begin
      Add2Line('|05New game')
      initialize_game
      randomize_price
      Encounter
    End
    'C':Begin
      Write('|13Modifying the game in progress:')
      //modify_game
      ReadKey
    End
    'S': Begin
					Add2Line('|10Steal from homey')
					ReWriteWin
					Steal
				End
    'H': online_help
    'B': Action:=Action
  End
	MainMenu
  Update
End

Procedure Play
Var action  : Char =''
Var I6,I7  : LongInt
Begin 
  While Plyr.City = Plyr.LastCity Do Begin 
    /*if the Plyr hasn't moved*/
    Update              /*Update the screen*/
    TheCops            /*see if the cops show up*/
    WinWrite('|11') /*ask what to do*/
    WinWrite('|11So what next, G?  ') /*ask what to do*/
    action:=OneKey('VBSJTPQRDKM',True)
    Case action Of /*take the valid response*/
      'Q': Q2BBS
      'R': Begin Build; Update; End
      'M': ExtraFunctions
      'B': Begin
        /*buy process*/
        Add2Line('|05Buy')
        WinWrite('You looks over de merchandise:')
        Buy
      End
      'S': Begin
        /*sell process*/
				Add2Line('|04Sell')
        WinWrite('You check fo cops and')
        WinWrite('pulls out yo shit:')
        sell
      End
      'J': Begin
        /*jet process*/
        Add2Line('|03Jet')
        WinWrite('You gets de fuck outa Dodge!')
        jet
      End
      'K': Begin
        /*Bank process*/
        Add2Line('|02Go to Bank')
        WinWrite('|04You goes to de Bank:')
        Bank  
      End
      'V': Begin
        If Plyr.City>1  Then Begin
          /*you have to be in Rockville*/
          Add2Line('|05See Vinnie')
          WinWrite('|05Vinnie be in '+CityName[1]+'!!!')
        End Else 
          vinnie  /*to go see vinnie*/
        Update
      End
      'T': Begin
        WinWrite('|05')    /*Transfer process*/
        if Plyr.City > 1 Then  Begin /*you have to be in Rockville*/
          WinWrite('Transfer dope')
          WinWrite('Yo Stash be in '+CityName[1]+'!!!')
        End Else 
          Transfer  /*to go to your Stash*/
      End
    End
  End          /*when the Plyr jets to*/
  Plyr.LastCity:=Plyr.City    /*another City, note it*/
  Plyr.DaysUsed:=Plyr.DaysUsed+1  /*one day passes*/
  If Plyr.Debt > 0 Then 
    Plyr.DaysLeft:=Plyr.DaysLeft-1  /*one less day to pay the Debt*/
  Plyr.Debt:=Plyr.Debt+(Plyr.Debt/3)  /*add interest to Debt*/
  Plyr.Bank:=Plyr.Bank+(Plyr.Bank/1000)  /*and to Bank account*/
  If Plyr.Health<100 Then 
    Plyr.Health:=Plyr.Health+1     /*heal one Health point*/
  If Plyr.DaysUsed % 30 = 0 Then Begin      /*if it's time to pay bills*/
    WinWrite('|02Time to pay de bills!')  /*print it*/
    If Plyr.Bank >= 3000 Then Begin        /*pay it*/
      Plyr.Bank:=Plyr.Bank-3000        /*from the Bank*/
      WinWrite('You writes a check.')
    End Else Begin                    /*or from Bank and Cash*/
      I6:=3000-Plyr.Bank
      If Plyr.Cash >= I6 Then Begin
        If Plyr.Bank > 0 Then Begin
          WinWrite('You writes a icheck.')
          WinWrite('and gets a money order.')
                  /*or from Cash only*/
        End Else 
          WinWrite('You pays dem out yo Pockets.')
        I6:=3000-Plyr.Bank
        Plyr.Cash:=Plyr.Cash-I6
        Plyr.Bank:=0
      End Else Begin                    /*if he can't afford it*/
        If Plyr.Debt = 0 Then
          Plyr.DaysLeft:=30
        Plyr.Cash:=Plyr.Cash+Plyr.Bank  /*borrow from vinnie*/
        I6:=5000-Plyr.Cash
        Plyr.Debt:=Plyr.Debt+I6
        Plyr.Bank:=0
        Plyr.Cash:=2000
        WinWrite('You has to borrow momoney from Vinnie!')
      End
    End
  End
  I6:=Plyr.DaysUsed/365
  If I6 > 0 Then Begin   /*if it's been a full year or more than one year*/
    WinWrite('|03Happy Anniversamary!')
    If I6>1 Then Begin    /*he's been selling dope*/
      WinWrite('You has been selling')
      WinWrite('dope fo '+Int2Str(I6)+' years!')
    End Else Begin
      WinWrite('You has been selling')
      WinWrite('dope fo a year!')
    End
    If  I6>19 Then Begin    /*if he's been selling dope*/
//      retired              /*twenty years, he retires*/
      WinWrite('|00')
    End Else Begin
      I6:=Plyr.Danger/100
      I6:=I6+1
      I7:=Plyr.DaysUsed/73
      WinWrite('Yo friends gives you some'+DrugName[I6]+' fo luck!')
      Plyr.Coat[I6]:=Plyr.Coat[I6]+I7
      Plyr.Total:=Plyr.Total+I7
      Plyr.Pockets:=Plyr.Pockets-I7
    End
  End
  //randomize_price           /*redetermine dope prices*/
  Update                 /*Update the screen*/
  Encounter               /*Check for Encounters*/
End

Procedure EndGame
Begin
  clrscr()
  WriteLn('|03Yo time is up!  After 30 days of buyin'' and sellin'' dope you hasn''t even gots')
  WriteLn('de money to pay Vinnie back!  And as we all knows, de Eye-talians doesn''t')
  WriteLn('puts up wid no shit from peoples dat owes ''em money.  Especially folks')
  WriteLn('what owes ''em '+Int2Str(Plyr.Debt) +' dollars!!! Damn, G, you is in some serious hurt now. And')
  WriteLn('don''t even thinks about getting no extensions.  They is gonna come over')
  WriteLn('here any time now to be bustin'' you up, and I ain''t stickin'' around to see.')
  WriteLn('Later, G.  If you makes it.')
End


Procedure Main
Var I,X		: Integer
Var Done	: Boolean = False
Var Today	: String = DateStr(DateTime,1)
Begin      /*main logic driver*/
  If Today <> Cfg.TodayDate Then Begin
		Cfg.TodayDate:=Today
		Cfg.GameDays:=Cfg.GameDays+1
		SaveCfg
		GameMaint
	End
  Randomize
  ClrScr
  X:=FindPlyr(UserAlias)
  If X = 0 Then Begin
    I:=1
    While ReadPlyr(I) Do Begin
      I:=I+1
    End
    Plyr.Idx:=I
    WriteLn('|11Welcome, |15new dealer!')
    Repeat
      Write('|14What do you want your street name to be? |15: ')
      Plyr.Alias:=Input(30,30,1,UserAlias)
      If InputYN('|CR'+Plyr.Alias+'!  |10Is that what you want? |11: ') Then Begin
        initialize_game    /*set up Plyr data*/
        Plyr.BBSName:=UserAlias
				Randomize_price
        SavePlyr(Plyr.Idx)
        Done:=True
				Add2News('|14          There''s a new dealer in town|06.....|07'+Plyr.Alias)
      End
    Until Done
  End Else 
		ReadPlyr(X)

  If Plyr.LastOn <> Today Then Begin
		Plyr.LastOn:=Today
	  Plyr.Fights:=Cfg.Fights
	  Plyr.Turns:=Cfg.Turns
	  Plyr.InTown:=True
	  SavePlyr(Plyr.Idx)
	End 

	ShowNews

  //randomize_price    /*determine prices*/
  build        /*build the screen*/
  WinWrite('|14Welcome back to the streets,')
  WinWrite('|11'+Plyr.Alias+'|14. The crack-heads')
  WinWrite('|14have missed you.')
  Encounter      /*do first Encounters*/
  while Plyr.DaysLeft > 0 Do  
    Play        /*play till time is up*/
  EndGame      /*do end game screen*/
  CleanUp      /*clean up*/
End

Procedure PlayerEdit
Var Done	: Boolean = False
Var I			: Integer = 1
Begin
	While Not Done Do Begin
		ReadOthr(I)
		ClrScr
		WriteLn('|14'+Program+' '+ProgVer+'|09 Player Editor|CR')
		WriteLn('|11A|03) |09Player Name  |11: '+Othr.Alias	)
		WriteLn('|11B|03) |09Turns Left   |11: '+Int2Str(Othr.Turns))
		WriteLn('|11C|03) |09Pockets      |11: '+Int2Str(Othr.Pockets))
		Write  ('|CR|03Command (Q=Quit, ]=Next, [=Prev)|11: ')
		Case OneKey('ABCDEFGHIJQ[]',True) Of
			'B': Begin
						Write('|03Turns Left |11:')
						Othr.Turns:=Str2Int(Input(10,10,1,Int2Str(Othr.Turns)))
						SaveOthr(Othr.Idx)
					End
			'C': Begin
						Write('|03Pockets|11:')
						Othr.Pockets:=Str2Int(Input(10,10,1,Int2Str(Othr.Pockets)))
						SaveOthr(Othr.Idx)
					End
			'Q': Done:=True
			']': If I>=PlyrCnt Then I:=1 Else I:=I+1
			'[': If I<=1 Then I:=PlyrCnt Else I:=I-1
		End
	End
End

Procedure GodMenu
Var Done	: Boolean = False
Begin
	While Not Done Do Begin
		ClrScr
		WriteLn(' |14'+Program+' '+ProgVer+' |09Sysop Menu|CR')
		Write  (' |11A|03) Profanity OK? : ')
		If Cfg.Rating Then WriteLn('|11Yes')
		Else  WriteLn('|12No')
		WriteLn(' |11B|03) |10Turns per day |09: |11'+Int2Str(Cfg.Turns))
		WriteLn('|CR|CR Player Starting Defaults')
		WriteLn(' |11C|03) |10Coat Pockets  |09: |11'+Int2Str(Cfg.Pockets))
		WriteLn(' |11D|03) |10Health        |09: |11'+Int2Str(Cfg.Health))
		WriteLn(' |11E|03) |10Guns          |09: |11'+Int2Str(Cfg.Guns))
		WriteLn(' |11F|03) |10Fights per Day|09: |11'+Int2Str(Cfg.Fights))
		WriteLn(' |11G|03) |10Starting City |09: |11'+CityName[Cfg.City])
		WriteLn(' |11H|03) |10Pub. Enemy #  |09: |11'+Int2Str(Cfg.Danger))
		WriteLn(' |11I|03) |10Cash          |09: |11'+StrComma(Cfg.Cash))
		WriteLn(' |11J|03) |10Bank          |09: |11'+StrComma(Cfg.Bank))
		WriteLn(' |11K|03) |10Debt          |09: |11'+StrComma(Cfg.Debt))
		WriteLn(' |11P|03) |10Player Edit')
		Write('|CR|03Command (Q=Quit)|11: ')
		Case OneKey('ABCDEFGHIJKQSP',True) Of
			'A'	: If Cfg.Rating Then Cfg.Rating:=False Else Cfg.Rating:=True
			'B' : Begin
						Write('|CR|03Turns per day |11: ')
						Cfg.turns:=Str2Int(Input(10,10,1,Int2Str(Cfg.Turns)))
						End
			'C' : Begin
						Write('|CR|03Coat Pockets to Start|11: ')
						Cfg.Pockets:=Str2Int(Input(10,10,1,Int2Str(Cfg.Pockets)))
						End
			'D' : Begin
						Write('|CR|03Health to Start|11: ')
						Cfg.Health:=Str2Int(Input(10,10,1,Int2Str(Cfg.Health)))
						End
			'E' : Begin
						Write('|CR|03Guns to Start|11: ')
						Cfg.Guns:=Str2Int(Input(10,10,1,Int2Str(Cfg.Guns)))
						End
			'G' : Begin
						Cfg.City:=Cfg.City+1
						If Cfg.City> 6 Then Cfg.City:=1
						End
			'Q' : Done:=True
			'P'	: PlayerEdit
		End
	End
	SaveCfg
End

Procedure Lobby
Var done	: Boolean = False
Begin
  While Not Done Do Begin
    WriteLn('|CL|CR');
    WriteLn('|14'+PadCt('Welcome to',79,' '));

    WriteLn('|CR|09'+PadCt(Program+' '+ProgVer,79,' '));
    WriteLn('|CR|14'+PadCt(ProgCR,79,' '));
    WriteLn('|14'+PadCt('All Rights Reserved.',79,' '))

    WriteLn('|CR|13'+PadCt('This game has been running for |11'+Int2str(Cfg.GameDays)+' |13days.',85,' '));
    WriteLn('|10'+PadCt('There are |11'+Int2Str(PlyrCnt)+'|10 active players.',85,' '));
    WriteLn('|12'+PadCt('The GameOp allows for |11'+Int2Str(Cfg.Turns)+'|12 turns a day.',85,' ')+'|CR')

    WriteLn('                 |14(|11B|14)|11egin DopeWars              |14(|11T|14)|11oday''s News    ');
    WriteLn('                 |14(|11L|14)|11ist Homeys                 |14(|11Y|14)|11esterday''s News');
    WriteLn('                 |14(|11I|14)|11nstructions                |14(|11R|14)|11ead Mail       ');
    WriteLn('                 |14(|11Q|14)|11uit                        |14(|11W|14)|11rite Mail      ');
		If Acs('s200') Then
	    WriteLn('                 |14(|11G|14)|11od Menu');
    
		Write  ('|CR                 |14Your Command: |11-> ');
    Case OneKey('BGLIQYTRZ',True) Of
			'Q': Begin
						Done:=True
						Q2BBS
					End
			'B': Done:=True
			'G': If ACS('s250') Then GodMenu
			'L': ListPlyrs
			'T': ShowNews
			'Y': ShowOlds
			'Z': If ACS('s200') Then GameMaint
		End
	End
End

Begin
  MenuCmd('NA','Playing DopeWars')
  GetThisUser
  DrugName[1]:='Coke'
  DrugName[2]:='Meth'
  DrugName[3]:='Dust'
  DrugName[4]:='Acid'
  DrugName[5]:='Herb'
  DrugName[6]:='Rock'
  
  CityName[1]:='Rockville'
  CityName[2]:='Northwest'
  CityName[3]:='Southeast'
  CityName[4]:='Arlington'
  CityName[5]:='The Mall'
  CityName[6]:='Alexandria'

  Gun_Name[1]:='n AK-47'
  Gun_Name[2]:=' 9mm pistol'
  Gun_Name[3]:='n Uzi SMG'
  Gun_Name[4]:=' 45 automatic'
  Gun_Name[5]:=' Beretta'
  Gun_Name[6]:=' 12 gauge pump'

  Randomize
	ReadCfg

  BBSUsrCnt:=0
  While GetUser(BBSUsrCnt+1) Do BBSUsrCnt:=BBSUsrCnt+1
  If BBSUsrCnt > 6 Then Begin
    For TI1:=1 To 6 Do Begin
      If GetUser(Random(BBSUsrCnt-2)+2) Then Begin
        Homey[TI1]:=StripMCI(UserAlias)
      End
    End
  End Else Begin
    Homey[1]:='Leroy'
    Homey[2]:='Peanut'
    Homey[3]:='Bubba'
    Homey[4]:='Tyrone'
    Homey[5]:='Clarence'
    Homey[6]:='Ren'
  End

  While ReadPlyr(PlyrCnt+1) Do PlyrCnt:=PlyrCnt+1

  GetThisUser

  DispFile(JustPath(ProgName)+'dopewars')
  ReadKey

  Lobby
  Main
	BoxClose(MainBox)
	ClassFree(MainBox)
End
